<template>
  <div class="daba">
    <div :class="{'hidden':hidden}" class="pagination-container ike">
      <el-pagination
        :current-page.sync="currentPage"
          :page-size.sync="pageSize"
          :layout="layout"
        :small="true"
          :page-sizes="pageSizes"
          :pager-count="pagerCount"
          :total="total"
          v-bind="$attrs"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
      />
    </div>
  </div>
</template>

<script>
import { scrollTo } from '@/utils/scroll-to'

export default {
  name: 'Pagination',
  props: {
    total: {
      required: true,
      type: Number
    },
    page: {
      type: Number,
      default: 1
    },
    limit: {
      type: Number,
      default: 20
    },
    pageSizes: {
      type: Array,
      default() {
        return [10, 20, 30, 50]
      }
    },
    // 移动端页码按钮的数量端默认值5
    pagerCount: {
      type: Number,
      default: document.body.clientWidth < 992 ? 5 : 7
    },
    layout: {
      type: String,
      default: 'total,  prev, pager, next'
    },
    background: {
      type: Boolean,
      default: true
    },
    autoScroll: {
      type: Boolean,
      default: true
    },
    hidden: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
    }
  },
  computed: {
    currentPage: {
      get() {
        return this.page
      },
      set(val) {
        this.$emit('update:page', val)
      }
    },
    pageSize: {
      get() {
        return this.limit
      },
      set(val) {
        this.$emit('update:limit', val)
      }
    }
  },
  methods: {
    handleSizeChange(val) {
      if (this.currentPage * val > this.total) {
        this.currentPage = 1
      }
      this.$emit('pagination', { page: this.currentPage, limit: val })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    handleCurrentChange(val) {
      this.$emit('pagination', { page: val, limit: this.pageSize })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    }
  }
}
</script>

<style scoped>
.ike {
  /* background: #fff; */
  text-align: center;
  height: 50px;
}
.daba{
  .pagination-container .el-pagination{
    left: 50%;
    transform: translateX(-50%);
  }
  .el-input__inner{
    border: 0;
    background: #E1E1E1;
  }
  .el-pagination button:disabled{
    background-color:#E1E1E1;
    color: #4B5A6D;


  }
  .el-pagination .btn-prev, .el-pagination .btn-next{
    background-color:#E1E1E1;
    color: #4B5A6D;
  }
  .el-pager li{
    /* margin-right: 5px; */
    background-color:#E1E1E1;
    color: #4B5A6D;
  }
  .el-pagination.is-background .el-pager li:not(.disabled).active{
    background-color:#03BF8A;
    color: #fff;
  }
  .el-pager li.active{
    background-color:#1890FF;
    color: #fff;
  }
  .el-pager li:nth-child(1){
    /* margin-left: 5px; */
  }
}

.pagination-container.hidden {
  display: none;
}
</style>
